package com.huimv.env.admin.controller;


import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.entity.EnergyElectricity;
import com.huimv.env.common.entity.EnergyEnvDevice;
import com.huimv.env.common.entity.EnergyWater;
import com.huimv.env.common.service.IEnergyElectricityService;
import com.huimv.env.common.service.IEnergyEnvDeviceService;
import com.huimv.env.common.service.IEnergyWaterService;
import com.huimv.env.common.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-14
 */
@RestController
@RequestMapping("/energy-water")
@CrossOrigin
public class EnergyWaterController {

    @Autowired
    private IEnergyWaterService energyWaterService;
    @Autowired
    private IEnergyEnvDeviceService envDeviceService;
    @Autowired
    private IEnergyElectricityService electricityService;

    @RequestMapping("/listPigpen")
    public Result listPigpen(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return energyWaterService.listPigpen(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listData")
    public Result listData(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return energyWaterService.listData(httpServletRequest, paramsMap);
    }

    @RequestMapping("/editTest")
    public void editTest(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String startDate = paramsMap.get("startDate");
        String endDate = paramsMap.get("endDate");
        String type = paramsMap.get("type");
        QueryWrapper<EnergyEnvDevice> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId).eq("device_type", type);
        List<EnergyEnvDevice> list = envDeviceService.list(queryWrapper);
        for (EnergyEnvDevice energyEnvDevice : list) {
            QueryWrapper<EnergyElectricity> queryWrapper1 = new QueryWrapper<>();
            queryWrapper1.eq("farm_id", farmId).eq("chip_code", energyEnvDevice.getDeviceCode())
                    .between("create_date", startDate, endDate);
            List<EnergyElectricity> waters = electricityService.list(queryWrapper1);
            for (EnergyElectricity water : waters) {
                float v = Float.parseFloat(water.getElectricityValue());
                DecimalFormat def = new DecimalFormat("0.0");
                String format = def.format(v * energyEnvDevice.getTransformer());
                water.setElectricityValue(format);
                electricityService.updateById(water);
            }
        }
    }

    @RequestMapping("/send1")
    private void sendDate19(@RequestBody Map<String, String> paramsMaps) throws Exception {
        String farmId = paramsMaps.get("farmId");
        QueryWrapper<EnergyEnvDevice> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId);
        List<EnergyEnvDevice> devices = envDeviceService.list(queryWrapper);
        //获取到完整的时间
        List<EnergyWater> list = new ArrayList<>();
        for (EnergyEnvDevice device : devices) {
            QueryWrapper<EnergyWater> queryWrapper1 = new QueryWrapper<>();
            queryWrapper1.eq("farm_id", device.getFarmId()).eq("chip_code", device.getDeviceCode());
            List<EnergyWater> waters = energyWaterService.list(queryWrapper1);
            for (EnergyWater water : waters) {
                list.add(water);
            }
        }
        HashMap<String, String> paramsMap = new HashMap<>();
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("result", list);
        paramsMap.put("Content-Type", "application/json;charset=utf-8");
        String post = HttpRequest.post("http://218.76.168.4:10010/huatongApi/energy-data/getData30")
                .headerMap(paramsMap, false).body(jsonObject.toJSONString()).timeout(30 * 1000).execute().body();
    }
}
